#!/bin/sh

# a small script to add  MAC/IP address searching capability
# in the dhcpd.leases files 

MYEUID=`id -u`

[ x0 != x$MYEUID ] && {
echo "Script has to be run as root user"
exit
}

# how many days of dhcpd.leases to keep 
KEEPHIST=30

echo "We will be keeping $KEEPHIST days of dhcpd.leases in /var/lib/dhcp/hist"

[ ! -d "/var/lib/dhcp/hist" ] && { 

echo "No /var/lib/dhcp/hist/"
echo "Creating.."

mkdir /var/lib/dhcp/hist
touch /var/lib/dhcp/hist/dhcpd.leases.tmp
chown  root:webuser /var/lib/dhcp/hist/dhcpd.leases.tmp
chmod 664  /var/lib/dhcp/hist/dhcpd.leases.tmp
}
 

[ ! -f "/var/www/cgi-bin/admin/hist.cgi" ] && {
echo "No /var/www/cgi-bin/admin/hist.cgi"
echo "Creating.."
cp  netreg/cgi-bin/admin/hist.cgi /var/www/cgi-bin/admin/

}



crontab -l | grep '/var/lib/dhcp/dhcpd.leases /var/lib/dhcp/hist/dhcpd.leases' 1>/dev/null  2>&1 || { 

echo "No crontab entry to backup dhcpd.leases"
echo "Creating"

crontab -l > crontab.saved
echo "28 13 * * * gzip -c /var/lib/dhcp/dhcpd.leases > /var/lib/dhcp/hist/dhcpd.leases.\`/bin/date \+\%F\-\%T\`.gz" >> crontab.saved

#This line can be used to delete some old files
echo "#27 17 * * * rm -f /var/lib/dhcp/hist/dhcpd.leases.\`/bin/date -d \"$KEEPHIST day ago\" \+\%F*\`" >> crontab.saved

crontab crontab.saved
rm -rf crontab.saved

echo "Crontab content"
echo
crontab -l

}
