#!/usr/bin/perl

# This CGI script is to block/unblock MAC adresses in ESP/NetReg
# add this line to /etc/sudoers USING visudo
# webuser zip2 = NOPASSWD: /usr/local/bin/netreg_block_mac.sh

use CGI qw/:standard/;
use Time::Local;

require "../variables.pl";
require "../scan_vars.pl";


$CONF="/var/lib/dhcp/netreg_ether.deny";
$BLOCK="/usr/local/bin/netreg_block_mac.sh";
$DHCPLEASES="/var/lib/dhcp/dhcpd.leases";


print header,
    start_html('MAC/IP address blocking');

print "<IMG SRC=$GFX/netreg-top-logo.gif><BR>";
print "<center><a href=admin.cgi>Admin.cgi</a></center>";
print    start_form;

print "MAC/IP address" , textfield('addr')," ";
print popup_menu(-name=>'Action', -values=>['List All','Full Block','Partial Block','Bandwidth Limiting Block','Unblock this address','Unblock All MAC addresses','Search']),br;
print "Comment:",br;
print textarea(-name=>'Comment',-size=>50, -maxlength=>100);




print br,submit('Submit'),reset,defaults('Clear'),end_form;


$action=param('Action');
$QADDR=param('addr');

if( $action eq "List All" ){
    print "<hr>";
    list_blocked();
    print end_html;
    exit;
}


# if parameters were specified and the addr is wrong - error!
if( param() and $QADDR !~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ and
    $QADDR !~ /^\w{1,2}\:\w{1,2}\:\w{1,2}\:\w{1,2}\:\w{1,2}\:\w{1,2}$/){

    print "Wrong MAC or IP address";
    print end_html;
    exit;
}


# if ip specified then we try to determine the MAC 

if($QADDR =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/){
    
    if( ($QADDR = ip_to_mac($QADDR)) eq ""){
	print "No MAC address for this IP ";
	print end_html;
	exit;}

}

# ethernet address normalization - leading zeros & upper case for hex numbers
if($QADDR =~ /^\w{1,2}\:\w{1,2}\:\w{1,2}\:\w{1,2}\:\w{1,2}\:\w{1,2}$/){
    @o=split(/:/,$QADDR);
    $QADDR = uc( sprintf("%02s:%02s:%02s:%02s:%02s:%02s",$o[0],$o[1],$o[2],$o[3],$o[4],$o[5]) );
}


if( $action eq "Search"){

    print "<hr>";
    is_blocked($QADDR);

}


%blk=("Full Block" => "-F", "Partial Block" => "-Q", "Bandwidth Limiting Block" => "-B", "Unblock this address" => '-A',
"Unblock All MAC addresses" => '-A');

if ( $action eq "Full Block" or $action eq "Partial Block"){
    print "<hr>";
    $comment=param('Comment');

    if($comment =~ /[;]+/){
	print "These characters are NOT allowed: ;";
	print end_html;
        exit;
    }
       
    `sudo $BLOCK $blk{$action} block $QADDR \' $comment \'`;
    print $entry;
    list_blocked();
    
}

if( $action eq "Bandwidth Limiting Block" ){
    print "<hr>";

    `sudo $BLOCK $blk{$action} block $QADDR $bandwidth_limit_pktrate $bandwidth_limit_pktburst`;
    list_blocked();
}


if( $action eq "Bandwidth Limiting Unblock" ){
    print "<hr>";

    `sudo $BLOCK $blk{$action} unblock $QADDR`;
    list_blocked();
}

if( $action eq "Unblock this address" ){
    print "<hr>";

    `sudo $BLOCK $blk{$action} unblockall $QADDR`;
    list_blocked();
}

if( $action eq "Unblock All MAC addresses" ){
    print "<hr>";

    open(B,"sudo $BLOCK -L |")|| print "Cant run $BLOCK:$!";
    while(<B>){
	chomp;
	($ether,@descr)=split;
	print "unblocking $ether ... <br>";
	`sudo $BLOCK $blk{$action} unblockall $ether`;
	
	}
    
    close B;

    list_blocked();
}



    print "<IMG SRC=$GFX/netreg-bottom-logo.gif><BR><FONT SIZE=2>";
    print "<a href=\"http://www.netreg.org/\">NetReg";
    print " v1.3</a> &copy;2002 Lawrence University</FONT>";
print end_html;


# 
sub list_blocked
{

    open(B,"sudo $BLOCK -L | ")|| print "Cant run $BLOCK:$!";
    while(<B>){
	chomp;
	($ether,@descr)=split;

	print;

#print "<A HREF=\"\#\" onClick=\"ConfirmDelete(\'/cgi-bin/admin.cgi";
#        print "\?action=FL\&USER=$QUERY\&MAC=$MAC\',\'$MAC\',\'$QUERY\')\; ";
#        print "return false\;\">";
#        print "<IMG SRC=/gfx/netreg-del.gif border=0></A>";

	print " <A HREF=block.cgi?addr=$ether&Action=Unblock%20this%20address><IMG SRC=/gfx/padlock-open.jpg border=0></A>";
	print "<BR>\n";





    }
    close B;

}

# 
sub is_blocked
{
    my $i=0;
    my $addr = shift;

#    print "-= is_blocked : $addr <BR>\n";
    
    open(B,"sudo $BLOCK -L |")|| print "Cant run $BLOCK:$!";
    while(<B>){
	chomp;
	($ether,@descr)=split;
	
	if($ether eq $addr){
	    print;
	    print " <A HREF=block.cgi?addr=$ether&Action=Unblock%20this%20address><IMG SRC=/gfx/padlock-open.jpg border=0></A>";

	    print "<br>";
	}
    }
    close B;

}


# retun MAC for an IP from dhcpd.leases
sub ip_to_mac
{

    my $ip_addr = shift;
    my $i=0;
    my $lip,$lends;

open(DHCP,"$DHCPLEASES") || die "Cant open $DHCPLEASES:$!";

while(<DHCP>)
{
if( /^lease (.+) \{/ ... /^\}/)
    { 
     $ip=$1;
     if(($ether)=$_=~/hardware ethernet (.+)\;/){
# adding index prefix for sorting later to extract the last ip address assigment
     $t{$ip}=$ether;
     $i++;
        }

   }
}

return ($t{$ip_addr});

}


