#!/usr/bin/perl

# 
# set my-vendor-class = option vendor-class-identifier;
# set my-options = binary-to-ascii (10, 8, "-",option dhcp-parameter-request-list);
#
# Oct 4/05

use CGI qw/:standard/;
use Time::Local;

$OUIFILE="/etc/netreg/oui.txt";
$DHCPLEASES="/var/lib/dhcp/dhcpd.leases";
$OPTIONS="/etc/netreg/dhcp-options-fingerprints.txt";
$indx=0;
%dev_fingerprint=();
%oui_db=();


read_oui() if -f $OUIFILE;

read_options();
parse_leases();



# format: $t{$indx}=[$t_ends{$indx},$t_ip{$indx},$t_options{$indx},$t_vendor{$indx},$t_ether{$indx}];
# sorting by dhcp ends time to get the latest active MAC addresses

foreach ( sort {$a->[0] <=> $b->[0]} (values %t)){ 


$tab_eth{$_->[4]}=$_; 


}






print header,
    start_html('ESP server - device listing');



# printing table 

print "<table border=\"1\"><tbody><tr><th>#</th><th>MAC Address</th>  <th>Guessed Device</th> <th>Requested DHCP Options</th><th>Vendor Code</th> <th>IP</th><th>Lease ends</th></tr>";


my $indx_num=1;



foreach (sort {$b->[2] cmp $a->[2]} values(%tab_eth)){

# sorting options to mach with database
	@so=split(/-/,$_->[2]);
	$_->[2]=join('-',sort{$a<=>$b}@so);

	($ss,$mm,$hh,$d,$m,$y)=localtime($_->[0]);
	$end_time = sprintf "%04d-%02d-%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;

# MAC venvor
	($e1,$e2,$e3,@re)=split(/:/,$_->[4]);
	$ven= uc("$e1:$e2:$e3");
	$mac_vendor=$oui_db{$ven};
#	print STDERR "$ven . $oui_db{uc($ven)};

    print "<tr> <td>$indx_num</td>  <td>$_->[4] <br> $mac_vendor</td> <td>$dev_fingerprint{$_->[2]}</td> <td>$_->[2]</td> <td>$_->[3]</td> <td>$_->[1]</td> <td>$end_time</td> </tr>\n";

$indx_num++;
}


print "</table>";


print "<br>*Sorted* DHCP options for all known devices:<br>";

foreach (keys(%dev_fingerprint)){

	print "$_ : $dev_fingerprint{$_}" . "<br>";

}



print end_html;


# retun MAC for an IP from dhcpd.leases
# sets these assosiated arrays
# %t_ends, %t_ip, %t_options, %t_vendor, %t_ether

sub parse_leases
{


$indx=0;

open(DHCP,"$DHCPLEASES") || die "Cant open $DHCPLEASES:$!";

while(<DHCP>)
{
    chomp;

if( /^lease (.+) \{/ ... /^\}/)
{ 

$ip=$1;     
$t_ip{$indx}=$ip if $ip ne "";

if ($_ =~ /set my-options = \"(.*)\"/){
$t_options{$indx} = $1;

}

if ($_ =~ /set my-vendor-class = \"(.*)\"/){

$t_vendor{$indx} = $1;
}


if ($_=~/hardware ethernet (.+)\;/){

    $t_ether{$indx} = $1;

}


if(($y,$m,$d,$hh,$mm,$ss)=$_ =~ /ends \d (\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/){

        $t_ends{$indx}=timegm($ss,$mm,$hh,$d,$m-1,$y-1900);
}
                 



#print "$indx $ip $_ \n";



if($ip eq ""){
#    print "--$indx,$t_ends{$indx},$t_ip{$indx},$t_options{$indx},$t_vendor{$indx},$t_ether{$indx}\n";
    $t{$indx}=[$t_ends{$indx},$t_ip{$indx},$t_options{$indx},$t_vendor{$indx},$t_ether{$indx}];
    $indx++;
    
}



}


}

}






# reading DHCP option file
# 

sub read_options{

my ($opts,@o,$dev);

open(OPTS,"$OPTIONS") || die "Cant open $OPTIONS:$!";

while(<OPTS>){

chomp;

next if /^#/;
next if /^$/;

$dev="";
$opts="";

($dev,$opts)=split(/:/,$_);

# stripping off "

if($opts =~ /\"(.*)\"/){
	$opts=$1;
}


	@o=split(/-/,$opts);
	$opts=join('-',sort{$a<=>$b}@o);

$dev_fingerprint{$opts}=$dev;


}

close OPTS;
}


# reading vendor MAC prefix
# 

sub read_oui{

    my $v;
    open(OUI,"$OUIFILE") || print STDERR "Cant open $OUI:$!";

while(<OUI>){

chomp;

next if /^#/;
next if /^$/;



if($_ =~ /([0-9a-f][0-9a-f])-([0-9a-f][0-9a-f])-([0-9a-f][0-9a-f])\s+\(hex\)\s+(.+)/i){

    $v ="$1:$2:$3"; 
    $oui_db{$v}=$4;

}

}

close OUI;
}


