#!/usr/bin/perl

# search for IP/MAC address in the group of dhcpd.leases files

use CGI qw/:standard/;
use Time::Local;
use Net::Netmask;

$SUBNETDAT="/etc/netreg/subnet.dat";
$DIR="/var/lib/dhcp/";
$LEASEFILE="$DIR/dhcpd.leases";
$DHCPDCONFNEW="/etc/dhcpd/dhcpd.conf.new";


print header, start_html('ESP: Manual registration of MAC address'),start_form;

print br;

my $leases;
my %trows;
my %reg_ether_tab=();


# here we NEED to read /etc/netreg/subnet.dat
# to get the private network ie 10.10.10.0/24


$priv_net=get_subnet($SUBNETDAT);
$block = new Net::Netmask($priv_net);



get_registered($DHCPDCONFNEW);
search_leases($LEASEFILE);




foreach (sort {$a cmp $b} (keys(%trows)) ){


$ee=(split(/,/,$_))[2];
    $tt{$ee}=$_;

}
    
print "<table border=\"1\"><tbody><TR><TH>MAC Address</TH>\
                    <TH>Client-Hostname</TH>  <TH>IP</TH>  <TH>Lease started</TH> <TH>Lease Expire</TH>";
print "<TH>Register manually </TH>";
print "</TR>";

foreach (keys(%tt)){


    ($r_start_time,$r_end_time,$r_ether,$r_ip,$r_client_hostname)=split(/,/,$tt{$_});

    next if $reg_ether_tab{$r_ether} == 1;

    next if param(ether . $r_ether);


    print "<TR><TD>$r_ether</TD> <TD>$r_client_hostname</TD> <TD>$r_ip</TD>  <TD>$r_start_time</TD>  <TD>$r_end_time</TD>";

print "<TD><font size=1>" . checkbox(-name => ether . $r_ether, -checked=>0,-value=>1,-label=>"") . "hostname". textfield("host" . $_) ."</TD></font>";

print "</TR>\n";

}


print "</table>";



print submit,reset,defaults('Clear'),end_form;

if(@l=param()){


    foreach (@l){


	if(($mac)=$_ =~ /^ether(.+)/){

# using specified hostname otherwise generated hostname

	    if( ($hostname = param("host" . $mac)) ne ""){
		$hostname =~ s/\s+/_/g;
		$hostname =~ s/\W+/_/g; 
	    }
	    else {
		$hostname=$mac;
		$hostname =~ s/\:/_/g;
	    }
	    
	    $hostname .= "-" . timegm(localtime);
	    


	
	($r1_start_time,$r1_end_time,$r1_ether,$r1_ip,$r1_client_hostname)=split(/,/,$tt{$mac});


	($ss,$mm,$hh,$d,$m,$y)=localtime();
	$r1_cur_time = sprintf "%04d%02d%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;

	
	    next if is_registered($DHCPDCONFNEW,$mac);

#converting written MAC to uppercase as per NetReg standard 
	    $mac=uc($mac);
	
	print "host $hostname { hardware ethernet $mac ;}\#Not available\#$r1_cur_time\#$r1_ip" . "<BR>";


	`echo "host $hostname { hardware ethernet $mac ; }\#Not available\#$r1_cur_time\#$r1_ip" >> $DHCPDCONFNEW `; 
    }


    }

}

print end_html;



#####################
# search dhcpd.leases 
#####################


sub search_leases
{

my $file = shift;
my %t=();
my $indx=0;
my $l_count=0;
my $rows="";

#print "- $addr $file";
open(F,$file) || die "Cant open:$file: $!";


while(<F>)
{

    next if /^#/;
    next if /^$/;

    $l_count++ if /^lease (.+) \{/;

    if( /^lease (.+) \{/ ... /^\}$/)
    {
	$ip=$1;
	
	next if $ip eq "";

	chomp;

	
        if( $block->match($ip) ){

## using count to distingfish different leases for the same ip
	    $indx = "$l_count" . "_" . "$ip";
	    $t{$indx} .= $_;

}

    }
}
close F;

for (keys %t){

    $line = $t{$_};

	if(($ip)= $line =~/lease (\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/){
	    ;
	}

         if(($y,$m,$d,$hh,$mm,$ss)=$line =~ /starts \d (\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/){

            $stime=timegm($ss,$mm,$hh,$d,$m-1,$y-1900);
	    ($ss,$mm,$hh,$d,$m,$y)=localtime($stime);
	    $start_time = sprintf "%04d-%02d-%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;
	}
                                                                                                                                                  
        if(($y,$m,$d,$hh,$mm,$ss)=$line =~ /ends \d (\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/){

            $etime=timegm($ss,$mm,$hh,$d,$m-1,$y-1900);
	    ($ss,$mm,$hh,$d,$m,$y)=localtime($etime);
	    $end_time = sprintf "%04d-%02d-%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;
	}
 
    $ctime=timegm(localtime);
                
        if(($client_hostname)= $line =~/client-hostname (.+)\;/){
        }
                                                                                                                                   
        if(($ether)= $line =~/hardware ethernet ([\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2})/){
        }


    if($client_hostname eq ""){
	$client_hostname="N/A";
    }



	if($ctime-$stime <= 86400 ){


#	    $rr="$ether,$ip,$start_time,$end_time,$client_hostname";
	    $rr="$start_time,$end_time,$ether,$ip,$client_hostname";

	    $trows_eth{$ether}=$rr;
	    $trows{$rr}=$rr;

	}
	

}



}

######################################
# get list of registered MAC addresses
######################################

sub get_registered
{
    my $file=shift;

    open(F,$file) || die "Can't open $file: $!\n";
    
    while(<F>){
	
        if(($reg_ether)= $_ =~/^host .+ \{ hardware ethernet ([\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2})/i){

	    $reg_ether_tab{lc($reg_ether)}=1;

	}
    }

    close F;
}


##################################################
# check if MAC is already registered
##################################################

sub is_registered
{
    my $file=shift;
    my $mac=shift;

    open(F,$file) || die "Can't open $file: $!\n";
    
    while(<F>){
	
	if($_ =~ /^host .+ \{ hardware ethernet $mac \; \}/i){
	    print "$mac has been already registered!<br>";
	    close F;
	    return 1;
	}
    }

    close F;
    return 0;
}










######################
# get subnet
######################
sub get_subnet
{
    my $file = shift;
    my $subnet;

    open(F,$file) || die "Can't open $file: $!";

    while(<F>){

	if($_ =~ /ResNet\:\d+\:(.+)\:/){
	    
	    $subnet=$1;
	}

  }
    close F;

    return $subnet;

}

