#!/usr/bin/perl

# This script is reside on a ESP server in /cgi-bin/ and 
# called by an ESP agent (checker_nr.exe)
# to sens host's ip,MAC,dhcp server,msg type when 
# IP address of a DHCP server different from the IP address of 
# ESP server - that's an indication that host is coming from behind
# a router
# Usage: /cgi-bin/routercheck.cgi 

# Prerequisites: 
# This script uses /usr/local/bin/routercheck.pl
# that writes/reads to/from /var/lib/dhcp/routercheck.db
# this file has to be writable by user under which httpd runs
# problem: How to delete records from this file?
# Updated: Nov 21/07, martynov



use CGI qw/:standard/;
use Time::Local;
require "variables.pl";
require "subnet.pl";


$script="/usr/local/bin/routercheck.pl";

print header(), start_html('ESP Router Check');
#print header("Cache-Control: no-cache, must-revalidate"), start_html('ESP Router Check');




if(param()){

    $netregip="n/a";
    $routercheckaction = "n/a";
    $ipaddress = "n/a";
    $macaddress = "n/a";
    $dhcpserverip = "n/a";

$netregip = param(netregip) if param(netregip) ne "";
$routercheckaction = param(routercheckaction) if param(routercheckaction) ne "";
$ipaddress=param(ipaddress) if param(ipaddress) ne "";
$macaddress=param(macaddress) if param(macaddress) ne "";
$dhcpserverip=param(dhcpserverip) if param(dhcpserverip) ne "";


my $t=timelocal(localtime);

# this is a ip of the router as ESP server sees it
$requester_ip = $ENV{REMOTE_ADDR};

$res = `$script $macaddress $ipaddress $dhcpserverip $t $routercheckaction $requester_ip`;

}
else {

#print "Router check";

    get_host_info();

open S, "$script |" || die "Cant run $script :$!";

print "<table border=1><tr><th>Host MAC<br>(local to host)</th><th>Host IP<br>(local to host)</th><th>Router MAC<br>(as ESP server see it)</th><th>Router / DHCPserver IP<br> (local to host)</th><th>Time</th><th>Message type to User [pass|warn|block]</th></tr>";

while(<S>){
    chomp;

    ($mac,$ip,$dhcp,$time,$msgtype,$req_ip)=split(' ',$_);

($ss,$mm,$hh,$d,$m,$y)=localtime($time);
$time_str = sprintf "%04d-%02d-%02d %02d:%02d:%02d", $y+1900,$m+1,$d,$hh,$mm,$ss;



if ($dhcp ne "n/a"){
    $dhcp = "<a href=/cgi-bin/admin/admin.cgi?action=FL&query=$dhcp>$dhcp</a>";
}

print <<EOR;
<tr>
<td>$mac</td>
<td>$ip</td>
<td><a href=/cgi-bin/admin/admin.cgi?action=FL&query=$RECORDS{$req_ip}>$RECORDS{$req_ip}</a></td>
<td>$dhcp</td>
<td>$time_str</td>
<td>$msgtype</td>
</tr>
EOR



}

print "</table>";

}


print end_html;



sub get_host_info {
    # Parse through the leases file to get user MAC address based on IP
    $DONE = 1;
    open(LEASES, "$LEASESPATH/$LEASESFILE") or
        error( "Could not open lease file: $LEASESPATH/$LEASESFILE" );
    while (<LEASES>) {
        if (!$DONE) {
            if ($_ =~ /ethernet/) {
                ($TRASH, $TRASH, $TRASH, $MAC) = split / +|\;/;
                $RECORDS{$LEASEIP} = uc($MAC);
            }
            if ($_ =~ /\}/) { $DONE = 1; }
        } elsif (($_ =~ /\{/) && ($_ !~ /\#/)) {
            ($TRASH, $LEASEIP) = split /\s/;
            $DONE = 0;
        }
    }
    close (LEASES);
#    if (!exists ($RECORDS{$IP})) {
#       error("No Lease Found");
#    }
}
