#!/usr/bin/perl

# This script checks for host with unregistered MAC address
# modified Sep2/04
use Net::Netmask;

%reg_mac=();

$SUBNETS_FILE="/etc/netreg/subnet.dat";
$DHCPD_CONF="/etc/dhcpd/dhcpd.conf";

# building table of registered MAC addresses
get_reg_macs();


open(SUBNETSF,"$SUBNETS_FILE") || die "Cant open /etc/netreg/subnet.dat :$!\n";

while(<SUBNETSF>){
    
    chomp;
    next if /^#/;
    ($net,@rest)=split(/:/,$_);
    print "$net\n";
}

$block = new Net::Netmask($net);

for $ip ($block->enumerate()){

    $res=`/sbin/arping -f -c 3 $ip`;
    undef $/;
    
    if ( $res =~ /Unicast reply from (.+) \[(.+)\]/ ){

	print "$2 $1 " . ( (defined($reg_mac{$2})) ? "Registered\n" : "Unregistered\n");
    }
}


sub get_reg_macs {

    open(F,$DHCPD_CONF) || die "Cant read $DHCPD_CONF :$!";
    
    while(<F>){
	
	if( $_ =~ /^host .+ \{ hardware ethernet (.+) \;/){
            $reg_mac{$1}=1;
	}

    }

}



