#!/usr/bin/perl

use Time::Local;


# report AntiVirus stats
# add this to crontab -e
# 0,15,30,45 * * * * /usr/local/bin/av_stats.pl  /var/log/httpd/access_log > /var/www/htdocs/avstats.htm.tmp; mv -f /var/www/htdocs/avstats.htm.tmp /var/www/htdocs/avstats.htm
# touch  /etc/netreg/esp_av.txt ; chown webuser.webuser /etc/netreg/esp_av.txt
# Modified: Dec 07/2005

$DHCPDCONF="/etc/dhcpd/dhcpd.conf";
$DHCPLEASES="/var/lib/dhcp/dhcpd.leases";
$av_db_file="/etc/netreg/esp_av.txt"; 
my %tab_ip=();
my %tab_mac=();
my %av=();
my %REG=();
my %reg_ether_tab=();

$time=localtime;

get_registered($DHCPDCONF);

read_file();


foreach $f (@ARGV){

open(F,$f) || die "Can't open $file:$!";

while(<F>){
    
    s/%20/ /g;
    chomp;

    $av_name="";
    $av_ver="";
    $av_status="";
    $av_eicar="";
    $av_srv="";


    if(($av_ip,$av_name,$av_ver,$av_status,$av_eicar)=$_ =~ /^(.+?) .+GET \/cgi-bin\/before.cgi\?WSCname=(.*)\&WSCversion=(.*)\&WSCstatus=(.*)\&EICAR=(pass|fail)/){
	
	if( $_ =~ /AV_SERVICE=(.*?) HTTP\/1\.0/){
	    $av_srv=$1;
	}

    $av_name="n/a" if $av_name eq "";
    $av_ver="n/a" if $av_ver eq "";
    $av_status="n/a" if $av_status eq "";
    $av_eicar="n/a" if $av_eicar eq "";
    $av_srv="n/a" if $av_srv eq "";



	$av{$av_ip}=[$av_name,$av_ver,$av_status,$av_eicar,$av_srv,0];

#	print "$av_ip = $av_name = $av_srv\n";

    }

    
    if( ($reg_ip)=$_ =~ /^(.+?) .+POST \/cgi-bin\/register.cgi/ and $_ =~ /Windows NT/ and $_ !~ /PowerPC|Win 9x|Debian|Linux|Windows 98|Macintosh/){


# went thru registration or not

	if(!defined($av{$reg_ip})){ 
	    $av{$reg_ip}=["DID NOT RUN AV"];
#	    print STDERR "--- $reg_ip ---\n"
	}
	else {
	    $av{$reg_ip}->[5]=1;
#	    $REG{$reg_ip}=$av{$reg_ip};
	    

	}

    }
}
}



parse_leases();

print "<html><title>AntiVirus run stats</title><body>Generated: $time  ;  (<font color=red>red</font> - unregistered host)<br><table border=1>\n";
print "<tr><th>#</th><th>IP</th><th>Anti Virus Name</th><th>version</th><th>Up-to-date</th><th>EICAR Test</th><th>Process</th></tr>";


my @miss=();
$n=0;
foreach $ip (sort_by_ip(keys(%av))){

    $reg_color="black";

    if( $av{$ip}->[0] eq "DID NOT RUN AV"){
	
	@miss=(@miss,$ip);
	    next;
	}

#    print "$ip @{$REG{$ip}}\n";

    next if $av{$ip}->[5] != 1;


    $n++;


    $reg_color="red" if !$reg_ether_tab{lc($tab_ip{$ip})};

    print "<tr><td><a name=$tab_ip{$ip}>$n</a></td><td><font size=-3><a href=/cgi-bin/admin/admin.cgi?action=FC&query=$ip>$ip</a><br><a href=/cgi-bin/admin/admin.cgi?action=FL&query=$tab_ip{$ip}>$tab_ip{$ip}</a><br>$tab_mac{$tab_ip{$ip}}</font></td><td><font color=$reg_color>$av{$ip}->[0]</font></td><td>$av{$ip}->[1]</td><td>$av{$ip}->[2]</td><td>$av{$ip}->[3]</td><td>$av{$ip}->[4]</td></tr>\n";



}

print "</table><p><p>\n";

print "<table border=1>\n";

foreach $ip (@miss){

    $reg_color="black";

#    print "$ip @{$REG{$ip}}\n";

    $n++;

 $reg_color="red" if !$reg_ether_tab{lc($tab_ip{$ip})};

#    print "<tr><td><a name=$tab_ip{$ip}>$n</a</td><td><a href=/cgi-bin/admin/admin.cgi?action=FC&query=$ip>$ip</a></td><td>$av{$ip}->[0]</td>\n";
    print "<tr><td><a name=$tab_ip{$ip}>$n</a></td><td><font size=-3><a href=/cgi-bin/admin/admin.cgi?action=FC&query=$ip>$ip</a><br><a href=/cgi-bin/admin/admin.cgi?action=FL&query=$tab_ip{$ip}>$tab_ip{$ip}</a><br>$tab_mac{$tab_ip{$ip}}</font></td><td><font color=$reg_color>$av{$ip}->[0]</font></td>\n";
    

}

print "</table><p><p>";




print "<center><h5>Not registered hosts, failed AV check</h5></center><table border=1>\n";
print "<tr><th>#</th><th>IP</th><th>Anti Virus Name</th><th>version</th><th>Up-to-date</th><th>EICAR Test</th><th>Process</th></tr>";

$nn=0;

foreach $ip (sort_by_ip(keys(%av))){
    


    if( $av{$ip}->[5] == 0 && $av{$ip}->[0] ne "DID NOT RUN AV"){
	
    $nn++;

 $reg_color="black";   
 $reg_color="red" if !$reg_ether_tab{lc($tab_ip{$ip})};

    print "<tr><td>$nn</td><td><font size=-3><a href=/cgi-bin/admin/admin.cgi?action=FC&query=$ip>$ip</a><br><a href=/cgi-bin/admin/admin.cgi?action=FL&query=$tab_ip{$ip}>$tab_ip{$ip}</a><br>$tab_mac{$tab_ip{$ip}}</font></td><td><font color=$reg_color>$av{$ip}->[0]</font></td><td>$av{$ip}->[1]</td><td>$av{$ip}->[2]</td><td>$av{$ip}->[3]</td><td>$av{$ip}->[4]</td></tr>\n";

}

}


open(AV,">$av_db_file") || die "Cant open: $av_db_file:$!\n";

foreach $ip (sort_by_ip(keys(%av))){
    

    print AV "$ip;$tab_ip{$ip};$tab_mac{$tab_ip{$ip}};$av{$ip}->[0];$av{$ip}->[1];$av{$ip}->[2];$av{$ip}->[3];$av{$ip}->[4];$av{$ip}->[5]\n";

}
close AV;

print "</table><p><p>\n";


print "</body></html>";









sub sort_by_ip
{    
return map { $_->[0] }
    sort {
    $a->[1] <=> $b->[1]      ||
    $a->[2] <=> $b->[2]      ||
    $a->[3] <=> $b->[3]      ||
    $a->[4] <=> $b->[4]
    }
map { [$_,(split /\./)]} @_;
}




sub parse_leases
{


$indx=0;

open(DHCP,"$DHCPLEASES") || die "Cant open $DHCPLEASES:$!";

while(<DHCP>)
{
    chomp;

if( /^lease (.+) \{/ ... /^\}/)
{ 

$ip=$1;     
$t_ip{$indx}=$ip if $ip ne "";

if ($_ =~ /set my-options = \"(.*)\"/){
$t_options{$indx} = $1;

}

if ($_ =~ /set my-vendor-class = \"(.*)\"/){

$t_vendor{$indx} = $1;
}


if ($_=~/hardware ethernet (.+)\;/){

    $t_ether{$indx} = uc($1);

}


if(($y,$m,$d,$hh,$mm,$ss)=$_ =~ /ends \d (\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d)\:(\d\d)/){

        $t_ends{$indx}=timegm($ss,$mm,$hh,$d,$m-1,$y-1900);
}
                 



#print "$indx $ip $_ \n";



if($ip eq ""){
#    print "--$indx,$t_ends{$indx},$t_ip{$indx},$t_options{$indx},$t_vendor{$indx},$t_ether{$indx}\n";
    $t{$indx}=[$t_ends{$indx},$t_ip{$indx},$t_options{$indx},$t_vendor{$indx},$t_ether{$indx}];
    $indx++;
    
}

}

}

foreach ( sort {$a->[0] <=> $b->[0]} (values %t)){ 
    $tab_ip{$_->[1]}=$_->[4];
}

foreach ( sort {$a->[0] <=> $b->[0]} (values %t)){ 
    $tab_mac{$_->[4]}=$_->[1];
}


}


sub read_file
{
    my(@f,$ip,$mac,$mac_ip,$name,$ver,$status,$eicar,$srv,$flag);
  
    if(-f $av_db_file){
	
	open(F,"$av_db_file") || die  "Can't open history file $av_db_file: $!";

while(<F>){

    chomp;

#$av{$av_ip}=[$av_name,$av_ver,$av_status,$av_eicar,$av_srv,0];    
#    print AV "$ip,$tab_ip{$ip},$tab_mac{$tab_ip{$ip}},$av{$ip}->[0],$av{$ip}->[1],$av{$ip}->[2],$av{$ip}->[3],$av{$ip}->[4],$av{$ip}->[5]\n";

    ($ip,$mac,$mac_ip,$name,$ver,$status,$eicar,$srv,$flag)=split(/;/,$_);
    $av{$ip}=[$name,$ver,$status,$eicar,$srv,$flag];
    $tab_ip{$ip}=$mac;
    $tab_mac{$mac}=$mac_ip;

#    print "$ip,$mac,$mac_ip,$name,$ver,$status,$eicar,$srv,$flag\n";


}

    close F;

}

}


######################################
# get list of registered MAC addresses
######################################
 
sub get_registered
{
    my $file=shift;
 
    open(F,$file) || die "Can't open $file: $!\n";
     
    while(<F>){
 
        if(($reg_ether)= $_ =~/^host .+ \{ hardware ethernet ([\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2}\:[\dabcdef]{1,2})/i){
 
            $reg_ether_tab{lc($reg_ether)}=1;
 
        }
    }
                                                                                                                 
    close F;
}
